#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

#include <netdb.h>
#include <unistd.h>

#include "event.h"

NCSevent::NCSevent()
{
  active = 0;
}

NCSevent::~NCSevent()
{
  if(data != NULL)
      free(data);
}

int NCSevent::save(int fd)
{
  if(active)
    {
      write(fd, &type, sizeof(int));
      write(fd, &timestamp, sizeof(struct timeval));
      write(fd, &port, sizeof(int));
      write(fd, &data_lenght, sizeof(int));
      if(data_lenght > 0)
	write(fd, data, data_lenght);
    }

  return 1;
}

int NCSevent::restore(int fd)
{
  read(fd, &type, sizeof(int));
  read(fd, &timestamp, sizeof(struct timeval));
  read(fd, &port, sizeof(int));
  read(fd, &data_lenght, sizeof(int));
  if(data_lenght > 0)
    read(fd, data, data_lenght);

  return 1;
}

int NCSevent::send(int sock)
{
  if(active)
    {
      addr.sin_family = AF_INET;
      addr.sin_port = port;
      addr.sin_addr.s_addr = gethostid();
      sendto(sock, data, data_lenght, 0, &addr, sizeof(struct sockaddr_in));
    }

  return 1;
}

int NCSevent::receive(int sock)
{
  int len;
  
  len = sizeof(struct sockaddr_in);
  data_lenght = recvfrom(sock, data, MAX_UDP_SIZE, 0, &addr, &len);
  gettimeofday(&timestamp);
  port = addr.sin_port - 2;
  type = ncsEventData;
  active = 1;

  return 1;
}

